#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "util.h"
#include "ranlib.h"
#include "header.h"


int main(int argc, char *argv[]){
  int t,u,p,points,r;
  long seed1, seed2;
  double vih, sum=0, sumsquared=0, average, stddev, Price_scratch[UNDERLIERS_SIZE][POINTS_SIZE];
  double pe,psum=0,psumsquared=0,paverage,pstddev;
  int index[POINTS_SIZE], Max1_scratch[POINTS_SIZE], Max2_scratch[POINTS_SIZE];
  time_t now;

  now = time(0);
  printf("Started %s\n",asctime(localtime(&now)));

  parse_args(argc,argv);

/*   for(p=0;p<POINTS_SIZE;++p){ */
/*     index[p] = pc+1; */ 
/*   } */

  phrtsd(PHRASE,&seed1, &seed2);
  setall(SEED1, SEED2);
  
  for(r=0;r<REPETITIONS;++r){
	 
	 for(p=0;p<POINTS_SIZE;++p){
		index[p] =  p+1;
	 }

    for(u=0;u<UNDERLIERS;++u){
      Price[0][u][0] = INITIAL;
      Prob[0][u][0] = 1.0/UNDERLIERS;
    }

    Max1[0][0] = 0;
    Max2[0][0] = 1;

    if(INITIAL>STRIKE){
      Value_if_exercised[0][0] = INITIAL-STRIKE;
    }else{
      Value_if_exercised[0][0] = 0;
    }

    /* Fill Price[][][], Max1[][], Max2[][] */
    for(t=1;t<TIMESLICES;++t){
      for(u=0;u<UNDERLIERS;++u){
        Number_with_max[t][u] = 0;
      }
      Ignore[t] = 0;
      Ignore_den[t] = 0;
      init_rng(t);
      points = points_on_timeslice(t);
      for(p=0;p<points;++p){
        generate_point(t,p);
      }
    }

    /* Sort Price[][][p], Max1[][p], and Max2[][p] by Max1[][p] */
    for(t=1;t<TIMESLICES;++t){
      p = points_on_timeslice(t);
      ibatcher_(Max1[t],index,&p);

      for(p=0;p<points_on_timeslice(t);++p){
        for(u=0;u<UNDERLIERS;++u){
          Price_scratch[u][p] = Price[t][u][p];
        }
        Max1_scratch[p] = Max1[t][p];
        Max2_scratch[p] = Max2[t][p];
      }
      for(p=0;p<points_on_timeslice(t);++p){
        for(u=0;u<UNDERLIERS;++u){
          Price[t][u][p] = Price_scratch[u][ index[p] -1];
        } 
        Max1[t][p] = Max1_scratch[ index[p] -1];
        Max2[t][p] = Max2_scratch[ index[p] -1];
      }
    }

    /* Fill Value_if_exercised[][] with payoffs */
    for(t=1;t<TIMESLICES;++t){
      for(p=0;p<points;++p){
        Value_if_exercised[t][p] = exp(-t*INTEREST)*(Price[t][ Max1[t][p] ][p] - STRIKE);
        if(Value_if_exercised[t][p] < 0) Value_if_exercised[t][p] = 0;
      }
    }

    /* Set Value on the last timeslice */
    for(p=0;p<POINTS;++p){
      Value[TIMESLICES-1][p] = Value_if_exercised[TIMESLICES-1][p];
    }


    /* Fill Value[][] -- ie the real work */
    for(t=TIMESLICES-2;t>0;--t){
      points = points_on_timeslice(t);
      for(p=0;p<points;++p){
        for(u=0;u<UNDERLIERS;++u){
          Prob[t][u][p] = 1.0;
        }
        vih = mesh_estimate_3(t,p);
        if(generate_mask(t,p) > 0){
          vih = mesh_estimate_3(t,p);
        }
        if(vih > Value_if_exercised[t][p]){
          Value[t][p] = vih;
        }else{
          Value[t][p] = Value_if_exercised[t][p];
        }
      }
    }
    vih = mesh_estimate_3(0,0);
  
    if(vih > Value_if_exercised[0][0]){
      Value[0][0] = vih;
    }else{
      Value[0][0] = Value_if_exercised[0][0];
    }

    sum += Value[0][0];
    sumsquared += Value[0][0]*Value[0][0];

     pe = path_estimate(); 
     psum += pe; 
     psumsquared += pe*pe; 

    printf("%f\t%f\t",pe,Value[0][0]);

    for(t=0;t<TIMESLICES-1;++t){
      printf("%f ",Ignore[t]/Ignore_den[t]);
    }
    printf("\n");
  }

  average = sum/(double)REPETITIONS;
  stddev = 1.0/sqrt((double)REPETITIONS-1)* sqrt( (sumsquared/(double)REPETITIONS) - (sum/(double)REPETITIONS)*(sum/(double)REPETITIONS));
  printf("mesh estimate = %f +/- %f\n",average,stddev);

  paverage = psum/(double)REPETITIONS;
  pstddev = 1.0/sqrt((double)REPETITIONS-1)* sqrt( (psumsquared/(double)REPETITIONS) - (psum/(double)REPETITIONS)*(psum/(double)REPETITIONS));
  printf("path estimate = %f +/- %f\n",paverage,pstddev);

  return 0;
}

int points_on_timeslice(int t){
  int c;

  c = (POINTS-MINPOINTS)/pow(EXPIRATION,POWER);
  return(MINPOINTS + c*pow(EXPIRATION*(double)t/(TIMESLICES-1),POWER));
}

 
